'Started in 2007 by Nastase Eodor nastase_eodor@yahoo.com

Type TFont
    private:
    FName      As String
    FBold      As Boolean
    FItalic    As Boolean
    FUnderline As Boolean
    FStrikeOut As Boolean
    FSize      As Integer
    FColor     As Integer
    FCharSet   As Integer 
    FParent    As HWND
    FBolds(2)  As Integer
    FCyPixels  As Integer
    Declare Sub Create
    public:
    Handle As HFONT
    Declare Property Parent As HWND
    Declare Property Parent(Value As HWND)
    Declare Property Name As String
    Declare Property Name(Value As String)
    Declare Property Color As Integer
    Declare Property Color(Value As Integer)
    Declare Property Size As Integer
    Declare Property Size(Value As Integer)
    Declare Property CharSet As Integer
    Declare Property CharSet(Value As Integer)
    Declare Property Bold As Boolean
    Declare Property Bold(Value As Boolean)
    Declare Property Italic As Boolean
    Declare Property Italic(Value As Boolean)
    Declare Property Underline As Boolean
    Declare Property Underline(Value As Boolean)
    Declare Property StrikeOut As Boolean
    Declare Property StrikeOut(Value As Boolean)
    Declare Constructor
    Declare Destructor
End Type

Sub TFont.Create
    IF Handle Then DeleteObject(Handle) 
    Handle = CreateFont(-MulDiv(FSize,FcyPixels,72),0,0,0,FBolds(FBold),FItalic,FUnderline,FStrikeout,FCharSet,OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FF_DONTCARE,FName)
    IF Handle Then
        SetProp(FParent,"FG",Cast(Integer Ptr,FColor))
        SendMessage(FParent ,WM_SETFONT,CUInt(Handle),True)
        InvalidateRect FParent,0,True 
    End IF
End Sub

Property TFont.Parent As HWND
    Return FParent
End Property

Property TFont.Parent(Value As HWND)
   FParent = value
   Create
End Property

Property TFont.Name As String
    Return FName 
End Property

Property TFont.Name(Value As String)
    FName = value
    Create
End Property

Property TFont.Color As Integer
    Return FColor
End Property

Property TFont.Color(Value As Integer)
    FColor = value
    Create
End Property

Property TFont.CharSet As Integer
    Return FCharSet
End Property

Property TFont.CharSet(Value As Integer)
    FCharSet = value
    Create
End Property

Property TFont.Size As Integer
    Return FSize
End Property

Property TFont.Size(Value As Integer)
    FSize = value
    Create
End Property

Property TFont.Bold As Boolean
    Return FBold
End Property

Property TFont.Bold(Value As Boolean)
    FBold = value
    Create
End Property

Property TFont.Italic As Boolean
    Return FItalic
End Property

Property TFont.Italic(Value As Boolean)
    FItalic = value
    Create
End Property

Property TFont.Underline As Boolean
    Return FUnderline
End Property

Property TFont.Underline(Value As Boolean)
    FUnderline = value
    Create
End Property

Property TFont.StrikeOut As Boolean
   Return FStrikeout
End Property

Property TFont.StrikeOut(Value As Boolean)
   FStrikeout = value
   Create
End Property

Constructor TFont
    Dim As HDC Dc
    Dc = GetDC(HWND_DESKTOP)
    FCyPixels = GetDeviceCaps(DC, LOGPIXELSY)
    ReleaseDC(HWND_DESKTOP,DC)
    FBolds(0) = 400
    FBolds(1) = 700
    FName     = "TAHOMA" 
    FSize     = 8
    FCharSet  = DEFAULT_CHARSET
End Constructor

Destructor TFont
    IF Handle Then DeleteObject(Handle)
End Destructor
