'Started in 2007 by Nastase Eodor nastase_eodor@yahoo.com

Type TTabItem
    private:
    FCaption As String
    FImageIndex As Integer
    public:
    Owner As HWND
    Index As Integer
    Handle As HWND
    Declare Property Caption As String
    Declare Property Caption(Value As String)
    Declare Property ImageIndex As Integer
    Declare Property ImageIndex(Value As Integer)
    Declare Constructor
    Declare Destructor
End Type

Property TTabItem.Caption As String
    Return FCaption
End Property

Property TTabItem.Caption(Value As String)
    Dim As TCITEM Ti
    FCaption = Value
    If Owner Then
        Ti.mask = TCIF_TEXT OR TCIF_IMAGE OR TCIF_PARAM
        SendMessage(Owner,TCM_GETITEM,Index,CInt(@Ti)) 
        Ti.pszText = StrPtr(FCaption)
        Ti.cchTextMax = Len(FCaption)
        SendMessage(Owner,TCM_SETITEM,Index,CInt(@Ti))
    End If
End Property

Property TTabItem.ImageIndex As Integer
    Return FImageIndex
End Property

Property TTabItem.ImageIndex(Value As Integer)
    Dim As TCITEM Ti
    FImageIndex = Value
    If Owner Then
        Ti.mask = TCIF_TEXT OR TCIF_IMAGE OR TCIF_PARAM
        SendMessage(Owner,TCM_GETITEM,Index,CInt(@Ti)) 
        Ti.iImage = FImageIndex
        SendMessage(Owner,TCM_SETITEM,Index,CInt(@Ti))
    End If
End Property

Constructor TTabItem
End Constructor

Destructor TTabItem
End Destructor
    
Type TTabItems
    private:
    FParent As HWND
    FTabIndex As Integer
    public:
    TabCount As Integer
    Tabs     As TTabItem Ptr
    'Images   As TImageList
    Declare Property Parent As HWND
    Declare Property Parent(Value As HWND)
    Declare Property TabIndex As Integer
    Declare Property TabIndex(Value As Integer)
    Declare Sub AddTab(BYREF FTab As TTabItem)
    Declare Sub DelTab(Index As Integer)
    Declare Sub InsertTab(Index As Integer,BYREF FTab As TTabItem)
    Declare Sub Clear
    Declare Constructor
    Declare Destructor
End Type

Property TTabItems.Parent As HWND
    Return FParent 
End Property

Property TTabItems.Parent(Value As HWND)
    FParent = Value
    If FParent Then
    End If
End Property

Property TTabItems.TabIndex As Integer
    Return FTabIndex
End Property

Property TTabItems.TabIndex(Value As Integer)
    FTabIndex = Value
    If Parent Then SendMessage(Parent,TCM_SETCURSEL,FTabIndex,0)
End Property

Sub TTabItems.AddTab(BYREF FTab As TTabItem)
    Dim As TCITEM Ti
    Dim As String s
    TabCount += 1
    Tabs = ReAllocate(Tabs,SizeOF(TTabItem)*TabCount)
    If Parent Then
        s = FTab.Caption
        Ti.mask = TCIF_TEXT OR TCIF_IMAGE OR TCIF_PARAM
        Ti.pszText = StrPtr(s)
        Ti.cchTextMax = Len(s)
        Ti.lParam = Cast(LPARAM,@FTab)
        SendMessage(Parent,TCM_INSERTITEM,TabCount-1,CInt(@Ti))
        FTab.Owner = Parent
        FTab.Index = TabCount -1
    End If
    Tabs[TabCount-1] = FTab
End Sub

Sub TTabItems.DelTab(Index As Integer)
End Sub

Sub TTabItems.InsertTab(Index As Integer,BYREF FTab As TTabItem)
End Sub

Sub TTabItems.Clear
    Tabs = cAllocate(0)
    TabCount = 0
    If Parent Then SendMessage(Parent,TCM_DELETEALLITEMS,0,0)	
End Sub

Constructor TTabItems
End Constructor

Destructor TTabItems
End Destructor

